(library (blockchain)

  (export string->sha256
          data-mine
          genesis-block
          genesis-block-hash)

  (import (ironscheme)
          (ironscheme clr))

  (clr-using System.Text)
  (clr-using System.Security.Cryptography)

  (define genesis-block (make-parameter "This is my genesis block."))

  (define genesis-block-hash
    (lambda ()
      (string->sha256 (genesis-block))))

  (define string->sha256
    (lambda (str)
      (let* ((utf8 (clr-static-prop-get Encoding UTF8))
             (bytes (clr-call UTF8Encoding (GetBytes String) utf8 str))
             (hash-fn (clr-new SHA256Managed))
             (raw-result (clr-call SHA256Managed
                                   (ComputeHash System.Byte[]) hash-fn bytes))
             (bits-str (clr-static-call BitConverter ToString raw-result))
             (clean-bits (clr-call String Replace bits-str "-" ""))
             (lower-bits (clr-call String ToLower clean-bits)))
        lower-bits)))

  (define data-mine
    (lambda (current-block-data previous-block-hash)
      (let* ((combined-data
              (string-append current-block-data "+" previous-block-hash))
             (result (string->sha256 combined-data)))
        result)))
)
